import es, os.path, os, time, errorlib

# Addon info
info			= es.AddonInfo()
info.name		= "Saycommand Logger"
info.version	= "0.1"
info.url		= "http://addons.eventscripts.com/addons/view/saycmd_logger"
info.author		= "Ojii"
info.basename	= "saycmd_logger"

# Some globals:
scl_commandList = []
logdir = es.ServerVar('eventscripts_gamedir') + '/saycmdlogs/'
commandFile = es.ServerVar('eventscripts_gamedir') + '/cfg/saycmd_logger.cfg'

def load():
	global logfile, currentday
	errorlib.registerAddon(info,'me@ojii.ch')
	new = False
	if not os.path.exists(logdir):
		os.mkdir(logdir)
		new = True
	logfile = open(logdir + time.strftime('%Y%m%d') + '_saycmdlog.log','a')
	currentday = time.strftime('%Y%m%d')
	if new:
		logfile.write('%-20s | %-50s | %-15s | %-25s\n' % ('SteamID','Username','Command','Time'))
		logfile.write('------------------------------------------------------------------------------------------------------------------------\n')
	es.addons.registerSayFilter(saycmd_filter)
	readCommandFile()
	
def es_map_start(e):
	global logfile,currentday
	if currentday != time.strftime('%Y%m%d'):
		logfile.close()
		logfile = open(logdir + time.strftime('%Y%m%d') + '_saycmdlog.log','a')
		logfile.write('%-20s | %-50s | %-15s | %-25s\n' % ('SteamID','Username','Command','Time'))
		logfile.write('------------------------------------------------------------------------------------------------------------------------\n')
	readCommandFile()
	
def unload():
	errorlib.unregisterAddon(info)
	es.addons.unregisterSayFilter(saycmd_filter)
	logfile.close()

def saycmd_filter(userid, message, teamonly):
	global scl_commandList
	text = message.strip('"')
	if text in scl_commandList:
		es.dbgmsg(1,'[SAYCMD-LOGGER] Player used command in list!')
		steamid = es.getplayersteamid(userid)
		username = es.getplayername(userid)
		command = text
		thetime = time.strftime("%a, %d %b %Y %H:%M:%S")
		logfile.write('%-20s | %-50s | %-15s | %-25s\n' % (steamid,username,command,thetime))
	return (userid, text, teamonly)
	
def readCommandFile():
	global scl_commandList
	scl_commandList = []
	if os.path.exists(commandFile):
		f = open(commandFile,'r')
		for line in f.read().splitlines():
			scl_commandList.append(line)
			es.dbgmsg(1,'[SAYCMD-LOGGER] Adding command: %s' % line)
		f.close()
	else:
		es.dbgmsg(0,'[SAYCMD-LOGGER] No config file found!')
		es.unload('saycmd_logger')